#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "mytime.h"

int *a;

int compare(const void *p1, const void *p2) {
    return (*(int *)p1 - *(int *)p2);
}


int
main(int argc, char *argv[])
{
    if (argc != 3) {
	fprintf(stderr, "usage: %s <repeat> <asize>\n", argv[0]);
	exit(1);
    }
    int repeat = atoi(argv[1]);
    int asize  = atoi(argv[2]);

    // init
    a = malloc(asize * sizeof(int));
    assert(a != NULL);

    int i;
    for (i = 0; i < asize; i++)
	a[i] = 0;

    printf("value: %d\n", a[0]);
    printf("repeat: %d  asize: %d\n", repeat, asize);

    // do timing loop
    double t1 = Time_GetSeconds();

    int j;
    for (j = 0; j < repeat; j++) {
	for (i = 0; i < asize; i++) {
	    a[i] += 1;
	}
    }

    double t2 = Time_GetSeconds();

    printf("value: %d\n", a[0]);

    printf("total time (seconds): %f\n", (t2 - t1));
    printf("ns per iteration: %f\n", (1e9 / ((double)asize * (double)repeat)) * (t2 - t1));


    return 0;
}

